2004-11-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Added import alias handling to
	searchImportedModulesForDefinition. removes dependency on getTypeOf.
	
	* bike/query/findDefinition.py: Fixed a bug where if was finding
	defn from a function call 'e.g. theFunction()', and call was made
	in a method of same name, would find the method rather than look
	for a function. (i.e. as if call was self.theFunction())

2004-11-18  Phil Dawes  <pdawes@users.sf.net>

	* bike/query/findDefinition.py: Fixed another bug unit testcase
	submitted by Aaron Bingham. This one highlighted that class scopes
	weren't being checked when finding variable definitions - this
	effected renames to class variables.

2004-11-17  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/test_rename.py: Fixed a couple of bugs which
	surrounded the renaming of keyword arg variables. The bug and
	testcases that helped me fix them were submitted by Aaron Bingham.

2004-10-22  Phil Dawes  <pdawes@users.sf.net>

	* bike/query/findReferences.py: Fixed a bug submitted by Parzival
	Herzog via Detlev Offenbach. Actually turned out to be 2 bugs in
	one - the first was that function args get erroneously renamed if
	they are the same name as a global, and the second was that
	default args *don't* get renamed.

2004-10-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Committed Adam Feuer's and Troy
	Frever's patch to better handle different tab sizes in extractMethod

2004-06-01  Phil Dawes  <pdawes@users.sf.net>

	* ide-integration/BicycleRepairMan_Idle.py: Committed Kerim
	Borchaev's patch to fix corrupted symbols.

2004-02-18  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Added feature to
	resolveImportedModuleOrPackage that searches the package hierarchy
	of the scope even if it isn't in the pythonpath.

2004-02-11  Phil Dawes  <pdawes@users.sf.net>

	* bike/query/getTypeOf.py: rewrote resolveImportedModuleOrPackage
	to use purely getModuleOrPackageUsingFQN searches. (doesnt use
	getTypeOf Root searching any more)
	
	* bike/query/common.py: rewrote getLogicalLine to handle
	multilines that parse seperately. (But was submitted by Peter
	Astrand)

2004-02-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Added functionality to search from the
	current directory if looking for an import and scope is a module

2004-02-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/moveToModule.py: Added handling of individual
	'from a.foo import theFunction'.

	* bike/parsing/fastparserast.py: Added Peter Astrand's patch to
	fix following bug:
	'Find-References (and probably others) fails if there is more
	whitespace than a single space between the "class"/"def" keyword
	and the class/def name.'

	* bike/query/common.py: fixed bug in just-written-code where no
	dest in Printnl causes npe.
	
	* bike/query/common.py: Fixed a bug in MatchFinder. Printnl ast
	nodes (print >>foo, bah) look at there children the opposito way
	to the way the text comes. (i.e. they do visit(bah), visit(foo) in
	the example above). Wrote code to get round this.

2004-02-09  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/moveToModule.py: added more functionality to
	moveFunction

	* bike/bikefacade.py: added expanduser to normalizeFilename so
	that ~/src/foo gets turned into a proper full path.

	* bike/bikefacade.py: exposed moveClassToNewModule.

	* bike/refactor/moveClass.py: started move-class-to-new-module
	refactoring.

2004-02-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/pathutils.py: new module containing all the
	functions that search all the files in the pythonpath.

	* bike/parsing/extended_ast.py: Removed this module. SourceFile is
	now in load.py, the rest is in fastparserast.py

	* ide-integration/BicycleRepairMan_Idle.py : Added patch from
	Steve <thepindropper@yahoo.com.au> to allow easier saving of files
	before refactoring in IDLE

2004-02-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: lots of cleanup. Renamed Source
	class to SourceFile. Slimmed down Package and Root. Am planning on
	removing this module completely, and moving the classes into other
	modules.


	* bike/refactor/extractVariable.py: refactored and removed
	extractLocalVariable_old

	* bike/refactor/extractMethod.py: refactored and removed
	extractMethod_old

	* bike/refactor/test_rename*.py: Removed the 'rename twice'
	tests. They are no longer applicable (since BRM saves to disk
	after each refactoring)

	* bike/transformer/: Moved save.py and undo.py into the
	transformer package

	* bike/parsing/newstuff.py: moved generatePackageDependencies into
	the parsing package, because it needs to be used by other modules
	in the parsing package.

2004-02-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/relationships.py: Added generatePackageDependencies
	which given a file in a package hierarchy, yields a list of
	external packages and modules used by the package.

	* bike/parsing/newstuff.py: Rewrote
	generateModuleFilenamesInPythonPath wrt new ref search scheme.
	Scheme: If the module you are searching from is in a package
	hierarchy, scan every module in the hierarchy, and the files in
	the directory above it (since they can reach the package without
	including it in PYTHONPATH).
	If the module is in a non-package directory, search in all files
	in the directory, and in any packages below that directory.
	N.B. this is in addition to directories in the PYTHONPATH.

2004-02-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/newstuff.py: Removed getRegexMatchesInPythonPath

	* bike/parsing/newstuff.py: Modified getSourceNodesContainingRegex
	to search the pythonpath + the set of python files in the
	directory above the root package of the current file. This should
	remove the requirement to add the root directory to the python
	path, and thus prevent BRM from finding references in other
	package structures.

	* bike/query/common.py: Removed scanASTSourceNodesForMatches and walkSourceNodes

	* bike/globals.py: Added True/False declaration for python 2.2
	back-compatibility.

2004-01-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: Added code to check for \ in a previous
	line when locating logical lines

2004-01-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: Added a test and fixed a bug that meant
	find-definitions from multiline statements wouldn't work if the
	braces were equalised on the following line. 
	(thanks again to Detlev for reporting this bug)

2004-01-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: Added a test and fixed a bug that meant
	find-definitions from multiline statements wouldn't work. 
	(thanks to Detlev for reporting this bug)

2004-01-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load.py: Added Detlevs patch to not recurse into
	subversion directories.

2004-01-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/newstuff.py: Added code in
	generateModuleFilenamesInPythonPath to ensure each filename is
	generated once. (and added test to check for it)
	(Thanks to Detlev & Syver for this bug report)

	* bike/query/common.py (globalScanForMatches): Removed old
	ast-based code from globalScanForMatches

2004-01-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Fixed bug where 'from foo import aou'
	would cause an assert to fail if foo didn't exist. (Thanks Syver)

2004-01-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Added code to normalize paths coming into
	BRM. (hopefully fixes Syver's problems on windows - Thanks Syver)

	
2003-09-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Fixed bug in
	Bicyclerepair_idle.

----------------------- 0.9 BETA4 -------------------------------

2003-09-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Fixed bug where brmctx
	was being tested for a __nonzero__ operator due to new wrapper
	stuff.
	Also made the matches window a singleton

	* bike/query/findReferences.py: Rewrote attribute reference
	finding algorithm to locate a possible match, and then check if
	the match class shares a common ancestor with the target. (rather
	than finding all classes in the target hierarchy and then testing
	each match class against the hierarchy).
	This results in a 10000% 

2003-09-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/relationships.py: Added buildClassHierarchy
	functionality to guess a class hierarchy, but found that it's
	still much too slow to handle the wxpython class hierarchy of 1900
	odd classes under 1 root!


2003-09-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/fastparserast.py: Added maskedsrc to the cache

	* bike/query/getTypeOf.py: Added caching of type lookups

	* bike/bikefacade.py: Added a generic wrapper which purges the
	caches before and after each brm ctx call

2003-08-31  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/newstuff.py: Added simple caching mechanism for
	sourceNodes

2003-08-30  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: Removed some crufty methods and
	base classes for managing the ast tree hierarchy

	* bike/bikefacade.py: Removed a couple of ast related methods

	* bike/query/findReferences.py: Modified the findRefs
	functionality to exclude matches where the confidence is high that
	it's *not* the right type.

	* bike/parsing/load.py: removed the load function (and made
	necessary refactorings to remove it)

2003-08-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Added setWarningLogger

2003-08-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: Fixed bug where "../.." was being
	added to sys.path. This was because extended_ast.py was adding
	importing setpath.py.

2003-08-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Added warning code to print message if
	sys.path is changed by setpath.py

	* ide-integration/test/README: Added ide tests for inline and
	extract variable

	* bike/bikefacade.py: Removed the load() function, and fixed
	inline and extract local variable

----------------------- 0.9 BETA3 -------------------------------

2003-08-22  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Fixed removeLibdirsFromPath to work with
	windows python lib directories

----------------------- 0.9 BETA2 -------------------------------

2003-08-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/*: Made it backward compatible with python 2.2

	* ide-integration/bike.vim: Adapted vim plugin to work with new
	api.

----------------------- 0.9 BETA1 -------------------------------

2003-08-20  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/test_*: Misc fixes for windows paths

	* ide-integration/BicycleRepairMan_Idle.py: Cleaned up error
	handling for undo stack

	* bike/query/*: Misc fixes for tests

	* bike/refactor/extractMethod.py: Updated to work with new
	non-tree system

2003-08-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/testutils.py: Converted createSourceNodeAt to create a
	directory structure rather than an ast. (and broke a load of tests)

2003-08-18  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/testutils.py: added test setup fixture to change directory
	before executing tests

2003-08-17  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Fixed bug which was stopping sub
	packages from being found properly

	* bike/query/relationships.py: Fixed getAllClassesInHierarchy and
	getAllDerivedClasses to work without AST. Uses a smart algorithm
	which scans the text of files with regexes for baseclassnames and
	import aliases to narrow down the likely candidates.
	

2003-08-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* README.idle: Updated docs for python2.3/idlefork

2003-08-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Added code to just use
	1 window for matches, and to reopen it if needed after it is closed

2003-08-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load.py: Fixed bug which cause BRM to descend into
	non-package directorys

	* bike/parsing/extended_ast.py: Added a couple of new functions to
	handle pythonpaths for queries and refactorings

2003-08-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: modified globalScanForMatches to scan
	files in addition to walking the ast.

	* bike/query/findReferences.py: Added code to work with new
	stateless design.

2003-07-31  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Removed module locating code from
	findDefinition, and made it use resolveImportedModuleOrPackage
	instead.

	* bike/query/getTypeOf.py: Modified resolveImportedModuleOrPackage
	to use the newstuff function getModuleOrPackageUsingFQN if it cant
	locate the module in the AST tree.

	* bike/parsing/newstuff.py: modified getModuleUsingFQN
	to handle packages. renamed to getModuleOrPackageUsingFQN 

2003-07-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Made necessary modifications 
	enable finding of function definitions without importing code
	(uses the python path to determine where to look). Doesnt work for
	methods yet.

2003-07-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/inlineVariable.py: Applied Jonathan's patch which
	fixes bug when multiple instances of a variable are on one line.

2003-06-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findReferences.py: changed findReferences interface
	to take a filename instead of a srcnode

	* bike/query/findReferences.py: Fixed bug where error wasnt being
	reported properly

2003-06-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findReferences.py: renamed findReferences to
	findReferences_old, and created a new findReferences which takes a
	filename instead of the srcnode

	* bike/bikefacade.py: Removed getFullyQualifiedNameOfScope - it's
	not used anywhere, and relies on the fqn stuff working.

	* all tests: attempted to remove all usage of fqn from
	tests. Instead, replaced with name and filename tests. This is
	because fqn is one of the major things binding the scopes
	together. 

	* bike/bikefacade.py: removed getTypeOfExpression. It's not used
	anywhere. Will reinstate when it is required again.

	* bike/query/getTypeOf.py: Fixed bug where a recursive function
	could cause BRM to stack overflow

2003-06-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Added resolveImportedModuleOrPackage fn
	to try and split the number of calls to getTypeOf()

	* bike/query/getTypeOf.py: Fixed bug where a[0].theMethod() would
	cause brm to barf.

	* bike/parsing/fastparserast.py: Beefed up the __str__ members for
	fastparser nodes

2003-06-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/output.py: Removed output.py. (functionality now in
	save.py)

2003-06-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: removed the ismodified stuff, in
	an attempt to make the xast hierarchy a read-only resource.
	Added a hook in save.py to update the xast whenever somebody
	queues an update to be saved.

	* bike/parsing/save.py: Added new save module which maintains its
	own queue of src to be written back to disk. Replaces output.py

2003-05-30  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/undo.py (UndoStack.undo): refactored to use dictionary

	* bike/query/findDefinition.py: Refactored main function to have a
	'stateless' interface (i.e. no need to pass a context).
	findAllPossibleDefinitionsByCoords(filepath,lineno,col)	

2003-05-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py (getRoot): Made the Root object a
	singleton. Use the getRoot() method to get it. This is an
	intermediate step in making the parser stateless. (idea is to make
	it pretend to be stateless by being a singleton, then once the
	interfaces have changed, transition the parser code to actually
	make it stateless)

2003-04-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Added exception catching and error
	reporting to bike-emacs integration

2003-03-31  Phil Dawes  <pdawes@users.sourceforge.net>

	* Applied Jonathan's patches
	    - InlineVariable handles multiline statements
	    - Fix to bike vim integration
	
2003-03-31  Marius Gedminas  <mgedmin@delfi.lt>

	* ide-integration/bike.vim: Removed unnecessary argument
	to BikeRename().

	* bike/query/common.py: Fixed handling of lambdas in MatchFinder.

2003-03-17  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractVariable.py: Made a start on the
	extract-local-variable refactoring

2003-03-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/inlineVariable.py: Made a start on the
	inline-local-variable refactoring

----------------------- 0.8 BETA2 -------------------------------

2003-03-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Fixed bug where
	paths with spaces meant that you couldn't select a reference when
	doing a findReferences. (Thanks to Andy Bulka for the report)

	* bike/query/getTypeOf.py: Added infinite recursion protection to
	getTypeOf

	* bike/query/relationships.py: Added some performance improving
	code when searching for a classhierarchy. Rather than doing a
	getTypeOf() on every base class, it finds the strings likely to be
	base classes (i.e. the name of the base class, and any 'import
	name as foo' lines) to narrow the search.

2003-03-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Fixed bug in extract method,
	where blank lines were messing up the indentation in the resultant
	block


----------------------- 0.8 BETA1 -------------------------------
	
2003-03-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Fixed bug in brm with emacs on
	windows, where the mark can be active and nil at the same time.

	* bike/bikefacade.py (BRMContext_impl.load): Fixed bug which
	affected windows users. Path needs to be saved after it's been
	normalized.

2003-03-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: fixed bug in attribute finding
	code - was only searching the first function

	* bike/query/getTypeOf.py: Fixed bug where x = x.bah() would cause
	recursion error. (just catches the stack overflow)

2003-03-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/*: implemented automatic importing of changed files. This
	means that ide integration stuff no longer has to import code into
	brm whenever it is saved.

2003-02-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bike.vim: Consolidated RenameMethod,
	RenameFunction and RenameClass into 1 menu option. This is because
	brm now supports renaming of variables and attributes and I didn't
	want to add another 2 menu items.
	

2003-02-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Fixed rename 'prompt'
	bug. Consolidated all the rename stuff into 1 menu option.

2003-02-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/*: removed getReferencesToClass/Function/Method and
	replaced with findReferences

2003-02-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findReferences.py: Added findReferencesIncludingDefn
	and made 'vanilla' findReferences not return the definition.  This
	paves the way for a unified rename that can be used to rename
	anything.	

2003-02-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Fixed bug reported by Marius - if
	class is declared in __init__.py, it blows up.

	* bike/query/findReferences.py: Fixed bugs in
	'getDefinitionAndScope' logic, so can handle nested classes etc..

2003-02-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getReferencesToClass.py: Replaced module logic
	with call to findReferences()

	* tests: modified or removed tests that tested for the erroneous
	'import a.b.bah.TheClass'. (A class or function can't be imported
	- only a module)

2003-01-24  Marius Gedminas <mgedmin@delfi.lt>

	* ide-integration/bike.vim: Show the line itself after finding
	references/definition.

2003-01-23  Marius Gedminas <mgedmin@delfi.lt>

	* bike/query/common.py: Fixed a trivial NameError in
	MatchFinder.visitGlobal().

2003-01-23  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Refactored and cleaned up the code in
	this module.

2003-01-22  Marius Gedminas <mgedmin@delfi.lt>

	* bike/query/common.py: Fixed another ValueError, this time on
	"from foo import bar" lines.

2003-01-20  Marius Gedminas <mgedmin@delfi.lt>

	* bike/query/common.py, bike/query/findDefinition.py,
	bike/query/findReferences.py: Fixed ValueError: list.index(x): x not
	in list" error caused by several visitFunction methods visiting
	their child nodes (argument names and default values) out-of-order.

2003-01-16  Marius Gedminas <mgedmin@delfi.lt>

	* bike/refactor/extractMethod.py: Now puts spaces after commas in
	generated code.

2003-01-15  Marius Gedminas <mgedmin@delfi.lt>

	* ide-integration/bike.vim: Better load failure diagnostics.

2003-01-14  Marius Gedminas <mgedmin@delfi.lt>

	* bike/bikefacade.py, bike/parsing/fastparserast.py,
	ide-integration/BicycleRepairMan_Idle.py: CRLF -> LF translation

2003-01-13  Marius Gedminas <mgedmin@delfi.lt>

	* bike/bikefacade.py: Added a function to check whether a given file
	was ever imported.

	* bike/test_bikefacade.py: Unit test for the above.

	* ide-integration/bike.vim: Added code to watch for modified files
	and reimport them into if they had been imported previously.

2003-01-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getReferencesToModule.py: Added Ender's
	getReferencesToModule module (and test module)

2003-01-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Added some find class attribute
	definition functionality

2003-01-09  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: fixed bug where 'import'
	statements in fn scopes weren't being searched

	* ide-integration/bike.vim: Modified Marius' bike.vim vi
	integration to support new rename and findReferences calls.
	
2003-01-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Added fix to redisplay frame in
	emacs, and to test for mark correctly in emacs.

2003-01-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* AUTHORS: Added Mathew and Marius

2003-01-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* README.emacs: Added simple instructions for installing pymacs.

	* ide-integration/Pymacs-0.20: I'm going to ship pymacs-0.20 with
	bicyclerepairman. I've modified it a little to make installation
	easier.

	* ide-integration/bikeemacs.py: Moved bikeemacs back to its
	original place.
	

2003-01-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: Cleaned this up a bit

	* bike/parsing/fastparser.py: Fixed bug reported by Mathew Yeates
	where more than one space between 'class' and the name foxed the
	parser.

2002-12-22  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findReferences.py: Started work on unified
	findReferences code. (uses findDefinition to compare matches)

	* ide-integration/emacs/bikeemacs.py: Rewrote emacs integration
	using the excellent pymacs package

2002-12-09  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Fixed findDefinition
	cosmetic bug

	* ide-integration/bike.el, bikeemacs: Added Syver Enstad's patch
	for allowing filenames with spaces

2002-12-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Completed support for
	findDefinition

	* ide-integration/bike.el: added code to handle the fact that if
	you select a region, the point is one greater than the end of the
	region and so misses it.

2002-12-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/findDefinition.py: Added code to scan for other
	method matches after locating the 100% one

2002-12-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Added basic
	finddefinition support to idle

	* ide-integration/bikeemacs.py: Added finddefinition support to xemacs

	* bike/bikefacade.py: Exposed findDefinition through bikefacade

	* bike/query/findDefinition.py: Added new query interface for
	finding the definition of a reference, given its line/col position
	in a module. Just supports function, method, and class references
	for now.

---------------------- 0.7 ---------------------------------------

2002-11-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bike.el: Fixed bug where saving buffers caused
	the new emacs protocol to get in a tangle. My solution was to add
	a disableMessages capability

---------------------- 0.7RC3 ------------------------------------

2002-11-22  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Added acknowledgement protocol, to
	get round synchronisation problems in windows emacs

2002-11-20  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing: decommissioned addtypeinfo, typeinfo, tokenutils,
	tokenhandler, matchTokensToAST, doublelinkedlist, testdata 

	* bike/query/getReferencesToClass.py: Fixed bug where 
	'from foo import *' would cause an exception if searching for a
	class called 'foo'

	* bike/*/test_*.py: Removed dependency on brmtransformer.

2002-11-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Rewrote extract method module to
	use all the new cool stuff (and operate or strings). Doesnt use
	linked lists, iterators, tokens, brmtransformer or any of that
	shite any more.

2002-11-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Fixed bug where classscope was being
	searched if the name wasnt found in methodscope. This is incorrect
	because class scope isn't visible except through 'self' or a fully
	qualified classname.

2002-11-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: Re-wrote MatchFinder to scan along the
	source code text when visiting ast nodes. This removes the need to
	match tokens in order to find the source code location of an ast
	node.

---------------------- 0.7RC1 ------------------------------------

	
2002-11-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/relationships.py: Added performance enhancement to
	getAllDerivedClasses. Now does string search on file before ast
	searching the classes.

2002-10-30  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Finished
	findReferencesByCoordinates support in idle.

2002-10-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Added trace
	console. Started integration of findReferencesByCoordinates into
	idle.

	* ide-integration/bike-emacs.py: Added xemacs support for
	getFullyQualifiedNameOfScope, getTypeOfExpression and
	findReferencesByCoordinates


2002-10-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Added getFullyQualifiedNameOfScope,
	getTypeOfExpression and findReferencesByCoordinates

2002-10-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: changed promptForRename callback signature
	to be linenumbers and columnnumbers

	* bike/refactor/renameMethod.py: Added prompt
	functionality. 

2002-10-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Added functionality to handle scanning
	for types of references (needed by getReferencesToMethod)

	* bike/query/getReferencesToMethod.py: Implemented to use
	common.py stuff

2002-09-30  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/common.py: Split out common query code into common.py

2002-09-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameFunction.py: Now uses the getReferences stuff
	
2002-09-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/transformer/WordRewriter.py: Split this class out of the
	renameClass module.	

	* bike/transformer: Added new transformer package to contain code
	which rewrites the internal representation of the sourcecode

	* bike/bikefacade.py: Implemented locateNode to use the new
	fastparserast stuff.

	* bike/parsing/extended_ast.py: Added code to set fqn (fully
	qualified name) attributes on the fastparser ast

2002-09-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameClass.py: Finished modification to use
	getReferencesToClass. 

2002-09-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getTypeOf.py: Refactored getType() functionality out
	of ast classes and into a query module.

	* bike/parsing/fastparser.py: Added parsing of import and from
	lines to fastparser, and optimised a little.

2002-09-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameClass.py: Started modification to use
	getReferencesToClass. 

2002-08-30  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/query/getReferencesToClass.py: New module which returns a
	sequence of references to a class

	* bike/parsing/fastparser.py: Wrote new parser which builds a tree
	of functions and classes, very quickly.

2002-08-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenutils.py: Fixed bug where attempting to
	tokenize small strings would result in attributeerror

2002-08-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/logging.py: Logging module. Eventually will be replaced by
	import logging, but for now is a copy of the code by Vinay Sajip
	(to save people from having to download the module)

	* bike/parsing/brmtransformer.py: Added simple fix - tuple being
	concatinated to list was causing problems


---------------------- 0.6.7 ------------------------------------
	
2002-07-31  Phil Dawes  <pdawes@users.sourceforge.net>


	* ide-integration/BicycleRepairMan_Idle.py: Added Canis fix for
	the bug which stopped brm from displaying the menu when starting
	idle via right-click file.

	* bike/bikefacade.py: Added Canis windows compatability fix for
	dealing with .pyw files

	
2002-07-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Fixed bug where extracting an
	expression from a line just below a block opener (e.g. if foo:)
	would cause a parse error.

2002-07-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* README.idle: Doc about problems on windows

---------------------- 0.6.6 ------------------------------------
	
2002-07-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/doublelinkedlist.py: Optimised to use a list rather
	than a class instance for each link element.

2002-07-17  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/typeinfo.py: Fixed bug - package wasn't checking
	parent packages (and Root) for types. This meant that modules
	imported from higher up the tree weren't being found.

	* bike/parsing/extended_ast.py: Renamed 'Top' to 'Root'

---------------------- 0.6.5 ------------------------------------

2002-07-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bike.el: Minor bug fix

2002-07-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bikeemacs.py: Added code so that it waits for
	buffer to be reloaded in emacs before sending the request to
	update the next one.

	* ide-integration/bike.el: Added bug fix - if prompt for rename
	was on file not loaded, emacs would send a message back to brm
	when it ran find-file, which buggered up the 'rename-this-method?' 
	interaction.

2002-07-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bike.el: Added support for GNU emacs

	* README.emacs: renamed from README.xemacs

	* 

2002-07-09  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Added code to handle more windows filename
	brokenness

2002-07-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Added same optimisation to
	renameMethod.

	* bike/refactor/renameClass.py: Added optimisation: source string
	is scanned for classname before visiting ast. (with the lazy ast
	creation this means that files aren't parsed unless they contain
	the keyword (or are linked to the source via function call).

	* bike/parsing/extended_ast.py: Refactored .source member into
	.getSource() method and implemented so that tokens are
	synchronised with source if they're modified. 

2002-07-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: Added lazy parsing of ast when
	source.getModule() is called.

	* bike/parsing/typeinfo.py: Added PackageTypeInfo which deduces
	child types by interrogating the package rather than relying on
	children to register themselves in the typeinfo. This was required
	to facilitate lazy parsing of ast. (since parse would have had to
	be done to add module node to package). A lookup of a module now
	causes getModule() to be called on the sourcefile, thus triggering
	parse of source into ast.

---------------------- 0.6.4 ------------------------------------

2002-06-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenutils.py: Added bug fix for superflous
	brackets. Basically, if brackets are unecessary (e.g. '(a).foo()')
	then they aren't in the parse tree but are in the token
	stream. This buggers up the token matching.
	This fix just ignores unmatching ')'s. It was the simplist thing
	that could possibly work, but may cause problems later - needs
	lots of testing.

---------------------- 0.6.3 ------------------------------------
	
2002-06-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenhandler.py: Fixed bug where getattr renamed
	all occurences of the methodattr in the rest of the tokens

2002-06-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Fixed bug where commend before
	the extracted block would make brm think it should be extracting
	an expression rather than a block.

	* bike/parsing/addtypeinfo.py: Fixed the same bug in _getImportedType

	* bike/refactor/renameClass.py: Fixed bug where the module search
	routine in the 'From foo import *' code was using the parent scope
	as the search position. This doesnt work if 'from' is nested in a
	class since parent scope is a module, not a package. Added method
	_getParentPackage() to handle this correctly.

2002-06-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Fixed the 'loop' bug. extract
	method will now recognise variables assigned to by the extracted
	function and used in a loop by the calling function.

2002-06-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Lots of refactoring prior to
	fixing a bug.

2002-06-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/doublelinkedlist.py: Rewrote 'insert' so that it
	doesnt move the iterator. Renamed old method to
	insertAndPositionIteratorOnNewElement.

2002-06-07  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Fixed the parse error when
	extracting code from an if...else... block. The problem was that
	the code below the extraction contained the 'else', but not the
	'if'. This is hacked around by inserting an 'if 1: <indent>
	pass'. This seems to work, but I welcome a better way of handling
	this.

	* bike/parsing/output.py: Added code to ensure that indent never
	dips below 0. This fixes a bug in parsing during method extracts
	out of nested blocks.

	* bike/refactor/extractMethod.py: Fixed the 'don't know what type
	this isAssAttr(Name('item'), 'decl', 'OP_ASSIGN')' bug

---------------------- 0.6 --------------------------------------
	
2002-05-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/test/*: Added manual test script for testing ide
	integration before a release
	
	* ide-integration/BicycleRepairMan_Idle.py: Now imports code into
	brm when loaded, or saved for the first time.

	* ide-integration/bike.el: Now imports all loaded python files
	into brm. Also checks to see if file was just updated to avoid
	superflous reloads.

2002-05-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/bike.el: Added menu for brm

	* bike/parsing/undo.py: Added an internal undo buffer size

	* ide-integration/BicycleRepairMan_Idle.py: Added generic
	exception reporting to idle

	* ide-integration/bikeemacs.py: Added generic exception
	reporting. All exceptions are handled and reported back to the
	user.

2002-05-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* ide-integration/BicycleRepairMan_Idle.py: Exposed undo to idle

	* ide-integration/bikeemacs.py: Exposed undo to emacs

	* bike/bikefacade.py: Exposed undo functionality to facade

	* bike/parsing/undo.py: Added undo functionality

2002-05-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/test_extractMethod.py: Fixed bug in expression
	extracting code (which caused a parse exception with correct code)

	* bike/bikefacade.py: Added public interface

---------------------- 0.5 --------------------------------------

	* ide-integration: Created new directory for integration modules 

2002-05-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/BicycleRepairMan_Idle.py: Exposed extract function to idle

	* bike/ui/bikeemacs.py: Exposed extract function to emacs

	* bike/refactor/extractMethod.py: Added support for extracting
	expressions into methods (e.g.  a = 1+2   ->  a = self.oneplustwo())
	Added support for extracting functions.

2002-05-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Extract Method pretty much
	finished. Now on with the testing...

2002-05-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/BicycleRepairMan_Idle.py: Added extract method support
	for idle

2002-05-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bike.el: implemented extract-method for emacs

	* bike/bikefacade.py: Exposed extract-method to the outside world

	
2002-05-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/extractMethod.py: Implemented simple extract
	method

2002-04-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/matchTokensToAST.py: The 'new' addtokens. Instead
	of each AST node getting its own slice of tokens, there is only
	one token list and each node has 2 linked list iterators pointing
	to the start and end of its tokens in within it.
	Thus the process of calculating the position of these iterators is
	now called 'token matching' rather than 'adding tokens to ast'.

	Having only 1 token stream vastly simplifies things. There are no
	consistency problems when renaming or moving tokens, and no need
	to 'divide' the comments amongst the AST nodes. 
	This enables one matching algorithm to be able to cater for all
	ast nodes without specialized logic.
	
	* bike/parsing/vector.py, bike/parsing/doublelinkedlist.py:
	containers which support the same bi-directional iterator
	interface. Used in refactoring the parsing module to use a linked
	list of tokens

2002-04-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/bikefacade.py: Removed use of tokens

---------------------- 0.4.3 ------------------------------------

2002-04-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/BicycleRepairMan_Idle.py: fixed import problem in
	windows

	* bike/parsing/load.py: Added code so that if you select a
	directory it will load all the modules and packages in it even if
	it isnt a package (i.e. doesnt have a __init__.py), but would
	recurse into non-package sub directories.

	* bike/ui/*: This is no longer a package, since the only 2 files
	are installed elsewhere.

	* setup.py: Made BicycleRepairMan_Idle.py a root level
	module. This means it can be used with idle by just adding
	[BicycleRepairMan_Idle] to your .idle file.
	

2002-04-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtokens.py: Addtokens class now takes tokens in
	constructor. The addTokens function is renamed to
	addTokensToASTFromSrc. This will pave the way for Source nodes to
	hold tokens rather than the source as a string

	* bike/parsing/tokenhandler.py: Fixed bug which caused name ast
	node to not be tokenized

	* bike/parsing/load.py: Added check for __init__.py before
	recursing into sub directories. This means that non-package sub
	directories will not be recursed into. (i.e. the user must load
	those seperately)

	
2002-03-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* NEWS: consolidated all README-version files into one NEWS file

	* README*: updated documentation

	* bike/ui/BicycleRepairMan_Idle.py: Fixed another windows filename
	isnt normalized bug

	* bike/ui/bike.el: Added same functionality as for idle

	* bike/ui/BicycleRepairMan_Idle.py: Added load on save
	functionality - means each saved python file gets automatically
	imported into bicyclerepairman.

2002-03-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load.py: Added functionality to deduce the package
	of the loaded module/package by inspecting parent directories for
	__init__.py modules. This allows adding of new modules to an
	existing AST.

2002-03-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* README.idle: Added Evelyn's ammendment to doc 

---------------------- 0.4.2 ------------------------------------

2002-03-23  Phil Dawes  <pdawes@users.sourceforge.net>

	* setup.py: Removed Icons stuff from setup

	* bike/ui/BicycleRepairMan_Idle.py: Fixed some bugs with idle
	integration in windows:
		- Ask if should rename dialogs dont take focus (which
	makes selection disappear in windows)
		- Filename normalizing means that filenames get compared correctly.

2002-03-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/testutils.py: Changed the test package structure generation
	code to add __init__.py modules to the packages. This will be used
	to work with the new loader code (when I write it).

2002-03-20  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/BicycleRepairMan_Idle.py: Fixed bug which was stopping
	changed files from being reloaded on windows

---------------------- 0.4.1 ------------------------------------

2002-03-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/BicycleRepairMan_Idle.py: Fixed bug where rename method
	prompts weren't visible to the user.

	* bike/parsing/addtypeinfo.py: Fixed a bug which meant that
	sourcenode wasnt getting added to default arguments, which caused
	brm to crash when attempting to tokenize these. 


---------------------- 0.4 --------------------------------------

2002-03-18  Phil Dawes  <pdawes@users.sourceforge.net>

	* setup.py: Removed bikegui and pyxmi from the setup
	program. These are now deprecated.

	* bike/ui/BicycleRepairMan_Idle.py: Added the idle support module
	to cvs.

	* bike/parsing/tokenhandler.py: Simplified SimpleTokenHandler

	* bike/parsing/extended_ast.py: Removed ExtendedNode base class -
	it isnt needed (thanks Evelyn)

	* bike/parsing/tokenutils.py: fixed bug in
	_getOffsetOfTokensCorrespondingToParseTree which was including the
	NL token in the offset it returned.

	* bike/bikefacade.py: Changed signature of rename method
	callback. It now sends filename and coords as args rather than
	exposing the ast nodes to the client.

2002-03-07  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/__init__.py: Moved bikefacade.py (from the ui package) into
	the bike package. This is now referenced from __init__.py so a
	client can do:   
	import bike;  ctx = bike.load("mypath"); ctx.renameMethod()
	

	* bike/parsing/typeinfo.py: ModuleTypeinfo.getTypeOf()
	functionality now uses the imported module *name* to check other
	modules, rather than a reference to the module itself. This is to
	allow module reloading.

	* bike/parsing/extended_ast.py: Added 'addtypeinfo' call to Source
	node. This is now done when the sourcenode is added to the parent
	node rather than being run once over the whole tree. This
	facilitates adding additional trees to the ast without having to
	run the whole addtypeinfo step again.

	* bike/parsing/addtypeinfo.py: Removed the subclasses stuff from
	the classtypeinfo functionality. Doing this at initial-parse time
	is too brittle, since a reload of a child source node could remove
	(or add) a subclass from a base class.
	Instead, subclasses are calculated at refactoring time.

	

2002-03-07  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py: Removed addfqn,
	addparentscopeToNode and addSourcenode to nodes functionality from
	the SourceModule, and integrated them with the first 'addtypeinfo'
	pass. This almost halves the initial parsing time.


2002-03-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Changed renameMethod signature to
	take a method fqn rather than class and method parameters. This
	allows the tests to take advantage of the same signature for
	renameMethod,renameFunction and renameClass.

	* bike/ui/bikeemacs.py: refactored to use the new bikefacade module

	* bike/ui/bikefacade.py: New module which provides easy interface
	into brm, for integrating into IDEs.

	* bike/parsing/test_addtypeinfo.py: Added recursion handling for
	things like a=a() (just catches the runtime error)

2002-02-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py: found a problem with lambdas - they
	take the reference from the outer scope. If the reference is a
	loop variable (e.g. for i in blah) then it is reassigned which
	knackers the closure.
	Solution -  lambda i=i: doSomethingWith(i)

	* bike/ui/bikegui.py: removed reliance on tokens

	* bike/parsing/tokenhandler.py: added getStartCoords() and
	getEndCoords() functions.
	

2002-02-27  Phil Dawes  <pdawes@users.sourceforge.net>

	* */setpath.py: code which insures pythonpath includes path
	to the bike module (used for running test scripts). This is
	imported by most modules.
	
	* bike/parsing/extended_ast.py: moved addParentScopeToNodes()
	functionality from addtypeinfo into Source class.

	* bike/parsing/addtypeinfo.py: For deduced types (e.g. types got
	from function calls), the closure of the type deducing function is
	put in the typeinfo rather than the type itself. The closure is
	then run at lookup.
	This facilitates lazy loading, and means source modules can be
	reloaded without invalidating the typeinfo objects.
	
2002-02-18  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikeemacs.py: Added reload source functionality

	* bike/ui/bike.el: Added support for renameMethod - prompts user
	for types that brm can't deduce

2002-02-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikeemacs.py: New support for emacs

	* bike/parsing/addtypeinfo.py: Fixed bug which was causing
	inheritance specs not to be renamed

	* bike/parsing/output.py: Added some code to preserve level of
	indent in multiline (comma ended) statements (e.g. function
	arguments, class inheritence args etc...). This really needs
	reworking into a general solution, but works 70% of the time for
	now.

2002-01-31  Phil Dawes  <pdawes@bea.com>

	* bike/parsing/output.py: Added comment indenting code which
	should preserve the indent level of comments

2002-01-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameClass.py: Added functionality to rename the
	function and class ref in 'import a.b.theFunction and from a
	import theClass' type statements

	* bike/parsing/renameFunction.py: new refactoring
	
	* bike/parsing/tokenhandler.py: Added code to update the typeinfo
	objects of the parent scope and the Top node. This enables renames
	to be carried out more than once on the same ast

	* bike/parsing/addtypeinfo.py: Removed node.typeinfo.fqn. refactor
	code should now use node.fqn

2002-01-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenhandler.py: Added token functionality to
	Name. Removed the getPreceedingTokens() stuff - the getTokens()
	now returns all tokens including preceeding comments, tokens
	etc... getNodeTokens() returns just the tokens associated with the
	node. This is consistent across all the tokenhandler base classes.

	* bike/parsing/tokenutils.py: Fixed bug in _appendTokens where
	the src 'raise foo' would result in 'raise' being picked up when
	searching for 'foo' because both tokens are of the same type (name).

2002-01-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtokens.py: Added code to class tokenizer to
	delegate tokens to the baseclass spec (i.e. bah in 
	'class foo(bah):'). 
	
	* bike/parsing/tokenhandler.py: Class handler stuff to output
	tokens (see above). This means that renameClass now renames class
	refs in baseclass specs.
	
2002-01-23  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Fixed a bug which stopped classes
	that inherited from classes not in the ast from having method
	declarations renamed.

2002-01-22  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/output.py: Added support for handling line breaks.
   	    i.e.   if foo and \
	              bah:

	* bike/refactor/renameClass.py: Started new refactoring -
	renameClass

	* bike/parsing/addtypeinfo.py: removed 'typing indirect recursive
	functions causes stack overflow' bug

	* bike/refactor/renameMethod.py: Refactored the code so that the
	renameMethodReferences is done once, with a list of all the
	classes (in the hierarchy) to match.
	

2002-01-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Now renames methods on all
	related classes (base classes and sub classes).

	* doc/*: added some html documentation
	
2002-01-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Did some major refactoring and
	removed all the code which is functionally duplicated in the
	addtypeinfo module.

	* bike/parsing/addtypeinfo.py: Spruced up the type inference
	stuff.
	ModuleTypeInfo now handles from foo import * by storing a list of
	other modules to search.

2002-01-17  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/output.py: Save now returns a list of the files modified

2002-01-16  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/extended_ast.py: Added lazy tokenization. Source
	node now parses the source (rather than being handed the ast).

2002-01-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/output.py: Added lazy saving. Files are only saved
	if source modified.
 
	* bike/testutils.py: Added new utility to find an ast node in a
	tree based on attributes of the node. 
	e.g. getMatchingASTNode(ast,"Function",name="foo")
 
2002-01-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Added functionality to look for
	method and ref renames in sub classes

2002-01-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py: Added support for imports, import
	from and import as statements

2002-01-09  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenutils.py: Fixed bug where method call was
	split over 2 lines. The problem is that the tokenlist contains the
	NL, but the parsetree doesnt, so the matching wasnt working. See
	addtokens test_doesntBarfWhenMethodCallSplitOverTwoLines for details.

	* bike/parsing/brmtransformer.py: Added 2 classes which override
	Print and Println, and return the child nodes in the desired order
	(they are the wrong way round as they come out of
	ast.py). The print_stmt method returns these.

	* bike/parsing/output.py: Added code to handle spacing with commas
	and stream operators

2002-01-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/test_renameMethod.py: Refactored tests so that
	BikeGUI can use them (through template method).  Tests are now
	split into RenameMethodTests,
	RenameMethodReferenceTests_ImportsClass and
	RenameMethodReferenceTests_doesntImportClass. This is because
	bikegui 
	
2002-01-07  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikegui.py: Added dialog to ask user if want to rename
	method reference (for cases where the type engine can't deduce the
	type of the instance)

2002-01-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikegui.py: Added a simple gui for renameMethod

2002-01-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load.py: Added functionality to strip of preceeding
	directories from package structures. (so if you load
	'/usr/local/python2.2/compiler', the root package is 'compiler')
	
	* bike/parsing/load.py: Added load_readonly(), which doesn't do the
	addtokens step. 
	Also added code to enable load() to be called more than once, to
	add new files and packages to the tree.
	Moved ui messages into constants module
	
2002-01-02  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/brmtransformer.py: removed addTokens() step from
	parse(), so that it must be called seperately. This is because it
	isn't complete, and imposes quite a performance penalty. (and it's
	not needed by pyxmi). Updated all the tests to reflect this.

2002-01-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py :  Added getSubClasses()
	functionality to class typeinfo.

2001-12-30  Phil Dawes  <pdawes@users.sourceforge.net>
	* bike/*: Fixed path bugs for windows platform. All tests run on
	win32 python now.
	
2001-12-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py: Added 'self' type to function
	typeinfo. This means renameMethod can handle self.theMethod()
	automatically.

2001-12-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* pyxmi: Wrote little tool to create xmi representation of python
	code. Suitable for loading into argouml.
	
	* bike/ui/bikecli.py: Added progress meter support. (also in
	addtokens.py, renameMethod.py, load.py and output.py

2001-12-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Fixed bug where function call
	returning instance resulted in crash. 'e.g. e().f()'

2001-12-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtokens.py: Reworked addtokens scheme to 'get all
	tokens for node, and then pass them to children to take their
	nodes'. This makes for a much easier time processing tokens.

2001-12-16  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenhandler.py: Changed Getattr rename
	functionality to work when attribute token isn't second token of
	node tokenlist

	* bike/refactor/test_renameMethod.py: refactored renameMethod
	tests into generic abstract base class. These are now used by the
	ui package (rather than vice versa)

	* bike/ui/bikecli.py: Added code to tell you how many changes have
	been made, and advice on what might be wrong if this number is 0.

2001-12-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/tokenhandler.py: Added getNodeTokens()
	implementation to miss out any preceeding cruft not picked up by
	addtoken functionality on previous nodes.

2001-12-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Changed renameMethodDefinition to
	work with nested methods (utilising the new typeinfo.fqn stuff).
	Removed findclass and findmethod.

2001-12-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikecli.py: Modified prompt message a bit. Added actual
	standard io stuff so that it works with a user input as well as
	through the test harness.

	* bike/refactor/renameMethod.py: Modified RenameMethodReferences
	to create a stack of scopes. The code uses the typeinfo from each
	scope to determine the type of references, and if it can't find
	the type there, it checks its own references deduced from the
	classname passed in. I.e. it assumes that the classname is a
	class, even if it can't find the definition, and renames instances
	derived from it.

	Also ammended the 'prompt user callback' code to only ask the user
	if the type engine doesnt know the type of the instance
	expression. (before now it was prompting if the type was not the
	same as the input classname)

2001-12-11  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/ui/bikecli.py: Added code to handle prompting the user for
	whether the method reference should be renamed.

	* bike/refactor/renameMethod.py: Added code to prompt user when
	type of object instance isn't known

2001-12-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor.py: now takes advantage of typeinfo stuff to
	deduce types of references
	
2001-12-03  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/addtypeinfo.py: New classes to deduce the types of
	references. Adds a typeinfo attribute to each scope ast node,
	which maps reference names to their types (currently as strings).

2001-11-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Added stack to maintain
	references to object instances while visiting package structure

2001-11-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Added support for 'from foo
	import *'
	
	* bike/ui/test_bikecli.py: Refactored tests so that all the single
	file tests are exercised in a package hierarchy context.

2001-11-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Added support to rename methods
	based on imported classes

2001-11-23  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/refactor/renameMethod.py: Refactored code (took out
	RenameMethod class, since wasnt using instance state). Added
	support for compound references (a.b.c.foo)

2001-11-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load_application.py: removed. (see load.py instead)

	* bike/refactor/renameMethod.py: Added support for fully qualified
	classnames in _findClass. e.g. a.b.bah.foo. This means that the ui
	now supports renaming package nested methods (but not their
	references).

2001-11-20  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing: Added fixes to parser module to reflect changes in
	python 2.2 compiler module

2001-11-16  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/output.py: new function 'save' saves an entire ast
	tree

	* bike/refactor/renameMethod.py: Adapted to take an ast rather
	than source file

2001-11-14  Phil Dawes  <pdawes@bea.com>

	* bike/parsing/load.py: Replacement for load_application.py using
	Juergen's pythius loader code. load() hierarchically loads a bunch
	of packages and modules into a big AST.

	* bike/parsing/extended_ast.py: Fleshed out Package and Top nodes
	to support hierarchical module ast


2001-11-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load_application.py: Fixed import visitor code to
	handle comma seperated imports. (i.e. import foo,bar). Added code
	to recognise imports via a from clause (i.e. from foo import bar)

	Removed Imports.py. Integrated code into load_application
	

2001-11-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/load_application.py: Added load_application and
	Imports modules back into build. Started writing tests for them.

	
2001-11-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* bike/parsing/brmtransformer.py : Rewrote this to override the
	methods which create nodes at the root of the parse. This means
	that a few methods adding parser nodelists to ast nodes should
	cater for practically all the AST nodes.

	* bike/parsing/tokenhandler.py (GetattrTokenHander.renameAttr):
	added renameAttr method which renames the attribute in the object
	state, and in the corresponding tokens.  This is a very brittle
	implementation, but will be fixed as new functionality is
	added. (it's the simplist thing right now)

	* bike/parsing/addtokens.py (AddTokens.visitGetattr): added
	token support for getattr

	* bike/parsing/tokenutils.py: Added getTokensPreceedingNodes,
	which takes a parsetree of nodes and returns all the tokens before
	the node represented by the parsetree. This is important because
	until there is an token-handling implementation of all the ast
	nodes, some tokens will be missed. By eating the tokens in between
	the implemented ast nodes, this ensures all the tokens will be
	outputted at the end.

	
2001-10-30  Phil Dawes  <pdawes@users.sourceforge.net>

	Created new CVS module, which makes use of distutils much more
	uniform.
	
	* setup.py: Created distutils setup stript: 

2001-10-25  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/output.py: Code to handle spacing in inline comments

	* refactor/renameMethod.py: Started code to handle references when
	object is created in same scope


2001-10-24  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/output.py: spaces in conditionals (a == b etc..)

	* parsing/tokenutils.py: Refactored code in TokenList to handle
	rearranging indent/dedent tokens so that whole-line comments are
	indented with the things they comment. The transformations are now
	done after the initial scan (slower, but easier to follow)
	
	
2001-10-23  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/output.py: ensured a.b not seperated by spaces. 

	
2001-10-22  Phil Dawes  <pdawes@users.sourceforge.net>
	
	* parsing/output.py: Code to seperate a=b with spaces (a = b)

	* ui/test_cli.py: Merged cli tests with renameMethod tests to
	ensure all tests work through the cli

2001-10-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* */testall.py: unified testing scripts so that all tests can be
	run from one place
	
2001-10-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* ui/cli.py: Added simple command line interface.

2001-10-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/output.py: Finished simple ast->string functionality
	
2001-10-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* testall.py: added master test script

	* parsing/tokenhandler.py (FunctionTokenHandler.rename): added
	rename a function and keep tokens in sync functionality


2001-10-12  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/output.py: started tokens -> string functionality

2001-10-07  Phil Dawes  <pdawes@users.sourceforge.net>
	* refactor/renameMethod.py: very basic findClass, findMethod
	functionality. Needs refactoring into analysis package, and
	merging with existing code
	
2001-10-05  Phil Dawes  <pdawes@users.sourceforge.net>

	* refactor/simplediff.py: wrote a simple diff utility to support
	writing top down tests. (i.e. do a renameMethod, then assert that
	the diff is correct)

	
2001-10-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* refactor/renameMethod.py: Got fedup with trying to secondguess
	what the parser module should do. Decided to do some top-down
	proper XP style development. Started with implementing the
	renameMethod story.

2001-10-01  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/test_addtokens.py: refactored tests so that they use
	brmtransformer to get a node, rather than mocking it.

2001-09-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/brmtransformer.py: Added nodelist to pass_stmt
	
2001-09-28  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/addtokens.py (AddTokens.visitModule): finished method

	* parsing/tokenutils.py
	(TokenConverter.getTokensUptoLastNewlineBeforeCode): method added

2001-09-27  Phil Dawes  <pdawes@users.sourceforge.net>
	
	* parsing/addtokens.py: started visitmodule() impl 

	* parsing/extended_ast.py: Added tokens support to Module

2001-09-26  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/test_addtokens.py Refactored tests. Made up better names.

2001-09-25  Phil Dawes  <pdawes@users.sourceforge.net>

	Laptop broke. Continuing with an older version of the code (hence
	the gap in changelog)

	* parsing/tokenutils.py (TokenConverter.getTokensToColon): Added
	function which just gobbles tokens to the next colon. Refactored
	getTokensStartBlock() to use this instead of walking the nodelist,
	since I think all 

	* parsing/addtokens.py (AddTokens.visitFunction): Now that
	function and class no longer need to pass in partial nodelists,
	the code is common. Refactored common code into
	visitCompoundNode().

	(hence the gap in the changelog)
	
	* parsing/tokenhandler.py: removed the preceeding tokens code -
	you ain't gonna need it!

	* parsing/test_addtokens.py: changed visitclass tests to use
	mockobjects

2001-09-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* parsing/tokenhandler.py: 

	* parsing/*: Integrated code with bike parsing package

	Split tokenhandler base classes into seperate module
	Merged brmast stuff into extended_ast package
	
	
2001-09-08  Phil Dawes  <pdawes@users.sourceforge.net>

	* test_tokenutils.py: Added more unit tests 

2001-09-06  Phil Dawes  <pdawes@users.sourceforge.net>

	* test_tokenutils.py: Added more unit tests 


2001-09-04  Phil Dawes  <pdawes@users.sourceforge.net>

	* test_addtokens.py: Added some mock objects and tests
	
2001-08-31  Phil Dawes  <pdawes@users.sourceforge.net>

	* test_tokenutils.py: beefed up the unit tests a bit

2001-08-29  Phil Dawes  <pdawes@users.sourceforge.net>

	* brmtransformer.py: This module now just contains code to add the
	nodelist member to each ast node as the compiler generates
	it. This is so the code in addtokens has access to the original
	python parser nodes to generate tokens from.

	* addtokens.py: Moved the code to add the tokens to the ast nodes
	to this module. It now relies on there being a 'nodelist' member
	on each ast object, containing the original python parser
	nodelist.

	* brmast.py: Added hack to retrofit TokenHandler base class to
	existing compiler.ast classes. This means that we no longer have
	to include compiler classes with the distribution. 
	Not sure if this is completely legal - doesn't work with jython.

	Removed stock Python compiler classes from src tree.
	

2001-08-27  Phil Dawes  <pdawes@users.sourceforge.net>
	Set about reimplementing the token stuff - will now add tokens to
	ast objects *after* the nodes have been processed by the compiler
	module.
	
2001-08-22  Phil Dawes  <pdawes@users.sourceforge.net>

	* tokenutils.py: Added support for tokenising strings as well as
	files.

	* test_tokenutils.py: removed testdata directory, and moved all
	the testdata into this module, now that the tokenutils stuff can
	take strings as well as files

	* brmtransformer.py: Renamed TransformerWithTokens to Transformer,
	now that it's in a seperate module.

	* brmast.py: Refactored the added token code out of ast module
	into this one. Created a seperate mixin called TokenHandler rather
	than sticking this code in the Node base class. Each class now
	re-inherits this baseclass.
	Unfortunately this means that I had to modify the transformer.py
	file to import brmast rather than ast. Need to think of a better
	way of doing this.

2001-08-21  Phil Dawes  <pdawes@users.sourceforge.net>

	* brmtransformer.py: Created new brmtransformer module and
	refactored token code from transformer.Transformer into seperate
	class TransformerWithTokens.  Refactored common code from
	funcdef() and classdef() into do_compound_stmt()

	* transformer.py: Now that all new code is factored out, reverted
	to original transformer module from Python-2.1/Tools/compiler.

	* tokenutils.py: Added code to alter DEDENT token line numbers
	when they are rearranged

2001-08-19  Phil Dawes  <pdawes@users.sourceforge.net>

	* tokenutils.py: Added code to do token reordering to ensure that
	comments immediately before a block of code are placed after the
	previous block DEDENT token.

2001-08-15  Phil Dawes  <pdawes@users.sourceforge.net>

	* transformer.py: tidied up code, and released prototype

2001-08-14  Phil Dawes  <pdawes@users.sourceforge.net>

	* ast.py: Refactored management of tokens into base Node
	class. Removed code from Class, and moved node->token conversion
	to transformer.py

	* transformer.py: See above
	
2001-08-13  Phil Dawes  <pdawes@users.sourceforge.net>

	* ast.py: Added support for tokens in 'Class' nodes. 'Class' uses
	nodes passed to convert to tokens using TokenConverter.

	
2001-08-10  Phil Dawes  <pdawes@users.sourceforge.net>

	* tokenutils.py: Started TokenConverter class to convert python
	parser nodes to tokens.

	* test_tokenutils.py: unit tests for above

------------------  One year later... -------------------------


2000-10-21 19:02  gwilder

	* context.py, refactor/.cvsignore, refactor/NewClass.py,
	refactor/Refactor.py, refactor/__init__.py:
	
	first refactoring: NewClass

2000-10-21 18:56  gwilder

	* kickstand/: test_HasFromStar.py, test_IsClass.py,
	test_IsGlobal.py, test_all.py, test_context.py,
	test_load_application.py, testdata/HasFromStar_tf1.py,
	testdata/HasFromStar_tf2.py, testdata/IsGlobal_tf1.py,
	testdata/load_application_tf1.expected,
	testdata/load_application_tf1.py,
	testdata/rf_addclass_tf1.expected, testdata/rf_addclass_tf1.py:
	
	more tests

2000-10-21 18:55  gwilder

	* analysis/: HasFromStar.py, IsClass.py, IsGlobal.py,
	Superclasses.py, TODO:
	
	more analysis functions

2000-10-21 18:38  gwilder

	* parsing/: .cvsignore, Imports.py, README, TODO, __init__.py,
	extended_ast.py, load_application.py:
	
	parse and load a whole app.

2000-10-13 19:32  gwilder

	* INSTALL, analysis/.cvsignore, analysis/IsClass.py,
	analysis/IsGlobal.py, analysis/README, analysis/TODO,
	analysis/__init__.py, assembly/genpy.py, kickstand/test_IsClass.py,
	kickstand/test_IsGlobal.py, kickstand/test_all.py,
	kickstand/testdata/.cvsignore, kickstand/testdata/IsClass_tf1.py,
	kickstand/testdata/IsGlobal_tf1.py:
	
	new analysis functions; install instructions; testsuite additions.

2000-09-28 00:59  eris

	* .cvsignore, CHANGES, README, assembly/.cvsignore,
	disassembly/.cvsignore, kickstand/.cvsignore,
	kickstand/test_common.py, kickstand/treefailtest.py,
	kickstand/treematchtest.py, kickstand/unequalvars.py,
	sprocket/.cvsignore, sprocket/common.py, sprocket/common.txt:
	
	
	added .cvsignore files in each dir got the unit test for
	sprocket/common.py working, added files for that test.

2000-09-06 01:21  jhermann

	* CHANGES, INSTALL, README, TODO:
	
	Added administrative files

2000-09-05 22:13  jhermann

	* assembly/__init__.py, disassembly/__init__.py,
	kickstand/__init__.py, sprocket/__init__.py:
	
	Made the inits non-empty

2000-09-05 22:11  jhermann

	* __init__.py:
	
	Minor correction

2000-09-01 18:33  jhermann

	* kickstand/__init__.py, kickstand/test_fsm.py,
	kickstand/test_regast.py, sprocket/__init__.py, sprocket/common.py,
	sprocket/fsm.py, sprocket/regast.py:
	
	Initial source checkin (2000-09-01)

2000-09-01 18:26  jhermann

	* .cvsignore, __init__.py, assembly/__init__.py, assembly/genpy.py,
	disassembly/__init__.py, disassembly/ast.py, disassembly/consts.py,
	disassembly/transformer.py:
	
	Initial source checkin (2000-09-01)

2000-09-01 18:22  jhermann

	* README:
	
	Additions by shae

2000-08-19 01:35  eris

	* README:
	
	
	new dir structure by snibril aka Jürgen Herrman first stab at a
	tree matcher in common.py

2000-08-01 01:44  jhermann

	* README:
	
	Added a readme dummy
